import java.util.Observable;
import java.util.*;

public class Model extends Observable
{
   /** The observers that are watching this model for changes. */
  private List<Observer> observers;

  // Constructor
  public Model()
  {
    this.observers = new ArrayList();
    setChanged();
  }

  // Add observer to be notified on change
  public void addObserver(Observer observer)
  {
    this.observers.add(observer);
  }

  // Remove an observer from opdate list
  public void removeObserver(Observer observer)
  {
    this.observers.remove(observer);
  }

   // Notify all observers shit went down
  public void notifyObservers()
  {
    for (Observer observer: this.observers)
    {
      observer.update(this);
    }
  }
}
